#Postbank = 1
#PB_Kontoauszug = "PB_Kontoauszug"

Procedure.i DatnameCheck(nr = -1)
      
   Protected file$ = GetFilePart(pv\dateiname)  

   If Left(file$, Len(#PB_Kontoauszug)) = #PB_Kontoauszug
      If nr = #Postbank
         pv\dateiname = ReplaceString(pv\dateiname, #PB_Kontoauszug, "")
      EndIf
      ProcedureReturn #Postbank
   EndIf

ProcedureReturn 0
EndProcedure

Procedure.s DateiAuswahlLoad(vorgabe$ = "")
   
   Protected file$ = GetCurrentDirectory() + GetFilePart(vorgabe$) 
   Protected patt$ = "Text (*.txt)|*.txt;|Alle Dateien (*.*)|*.*"
   Protected info$ = "Laden: Datei auswhlen oder neuen Namen eingeben"
   
   file$ = OpenFileRequester(info$, file$, patt$, 0)
   
ProcedureReturn file$
EndProcedure

Procedure.s DateiAuswahlSave(vorgabe$ = "")
   
   Protected file$ = GetCurrentDirectory() + GetFilePart(vorgabe$) 
   Protected patt$ = "Text (*.txt)|*.txt;|Alle Dateien (*.*)|*.*"
   Protected info$ = "Speichern: Datei auswhlen oder neuen Namen eingeben"
   
   file$ = SaveFileRequester(info$, file$, patt$, 0)
     
   pv\errorflag = 0
   If file$ = ""
      file$ = vorgabe$: pv\errorflag = 1
   EndIf
   
ProcedureReturn file$
EndProcedure

Procedure.i DateiLaden(titel, autostart = 0)
Protected j, dnr, k, file$, postflag
Protected oldname$ = pv\dateiname
  
With pv.myProgrammvariablen   

  If titel = 0
     For j = 1 To #maxfelder: \feldnamen[j] = Str(j): Next
  EndIf
  
  If autostart = 0  
     file$ = DateiAuswahlLoad(\dateiname)    ;18.06.2010 file$
     If file$ = "": ProcedureReturn
     Else: \dateiname = file$
     EndIf     
  ElseIf autostart = 1
    ;Programmstart mit folgender Datei
    \dateiname = GetCurrentDirectory() + \startdateiname
  ElseIf autostart = 2
    ;\dateiname wurde von LastFileOpen zugewiesen
  EndIf
 
  ;Check auf vorhanden
  If Not GetFileDate(\dateiname, #PB_Date_Created)
     Infomeldung(2, \dateiname + " existiert nicht !")
     \dateiname = oldname$
     ProcedureReturn
  EndIf
  
  If DatnameCheck() = #Postbank: postflag = 1: EndIf

  dnr = ReadFile(#PB_Any,\dateiname)  
  If dnr
     j = 0
     While Eof(dnr) = 0          
        
        If postflag: postflag = 0
           For k = 1 To 10: ReadString(dnr): Next
        EndIf
        
        \datensatz = ReadString(dnr)  
        If Right(\datensatz,1) <> #TAB$: \datensatz + #TAB$: EndIf
        ReplaceString(\datensatz, #TAB$, #LF$, #PB_String_InPlace)

        If j = 0  ;wird nur einmal ausgefhrt, um Liste zu erstellen
           j = 1
           \feldanzahl = CountString(\datensatz, #LF$) 
           If \feldanzahl > #maxfelder
             Infomeldung(4, "mehr als " + Str(#maxfelder) + " Felder"): End
           EndIf 
           CreateListIconGadget()
           HideGadget(#main_liste,1)   ;fr schnelleres Laden der Liste        
        EndIf
        
        If titel ;der 1. Datensatz ergibt die Titel der Spalten
           titel = 0
           For k = 1 To \feldanzahl
               \feldnamen[k] = StringField(\datensatz, k, #LF$)
               SetGadgetItemText(#main_liste, -1, \feldnamen[k], k)
           Next  
        Else
           AddGadgetItem(#main_liste, -1, #LF$ + \datensatz)
        EndIf
        
     Wend
     CloseFile(dnr)
     LastFilesSave(\dateiname)
  EndIf
  
  SetWindowDateiInfo()
  
  If IsGadget(#main_liste)     
     ListeAutosize(#main_liste) ;enthlt HideGadget(#main_liste,0)
     If \formatflag: FormatIniFile(\dateiname, #read|#write): EndIf
  Else
     StatusBarText(0, 2, "Fehler beim Laden")
  EndIf
  
EndWith
EndProcedure

Procedure.i DateiSpeichern(flag = 0)
Protected dnr, orderflag, item, x$

With pv.myProgrammvariablen   

  If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf
  
  If \dateiname = "" Or flag = 1
     If \dateiname = "": \dateiname = "miniadress.txt": EndIf  ;18.06.2010 diese Zeile eingefgt
     \dateiname = DateiAuswahlSave(\dateiname)
     If \errorflag: \errorflag = 0: ProcedureReturn: EndIf    ;Dateiauswahl wurde abgebrochen
  EndIf
  If Not GetExtensionPart(pv\dateiname): pv\dateiname + ".txt": EndIf 
  
  DatnameCheck(#Postbank)
  
  dnr = CreateFile(#PB_Any, \dateiname)
  If dnr
    orderflag = 1: GetOrderArray()                      ;mit OrderArray Datensatz holen
    For item = -1 To CountGadgetItems(#main_liste) - 1  ;ab -1 = incl. Spaltentitel
      x$ = Datensatzholen(item, orderflag)              
      ReplaceString(x$, #LF$, #TAB$, #PB_String_InPlace)
      WriteStringN(dnr, x$)   ;:Debug x$
    Next   
    CloseFile(dnr)
    LastFilesSave(\dateiname)
  EndIf
  
  SetWindowDateiInfo()
  If \formatflag: FormatIniFile(\dateiname, #write): EndIf 
  
EndWith
EndProcedure

Procedure.i DateiNeu()
;wird aufgerufen von: #menu_new

With pv.myProgrammvariablen   

   If IsGadget(#main_liste)
      If \dateiname And CountGadgetItems(#main_liste)
         DateiSpeichern()   
      EndIf
   EndIf
   
   \progflag = #menu_new
   SetWindowDateiInfo()

   SubWindowOpen("Felder neu", "Abbruch") 
   
   Protected x = 200, x1 = x + 10 + \buttonbr
   Protected y = 10, z = \subwinbrhh     ;z ist SubWindowbreite/hhe
   
   ListViewGadget(#feld_listview,   10, y, 170, z - 50)
   ButtonGadget  (#feld_nachoben,    x, y, \buttonbr, \buttonhh, "nach oben")   :y + #button_abstand
   ButtonGadget  (#feld_nachunten,   x, y, \buttonbr, \buttonhh, "nach unten")  :y + #button_abstand
   ButtonGadget  (#feld_loeschen,    x, y, \buttonbr, \buttonhh, "lschen")     :y + #button_abstand
   CheckBoxGadget(#feld_nameChkbox,  x, y, \buttonbr, \buttonhh, "Name ndern") :y + #button_abstand
   StringGadget  (#feld_nameEingabe, x, y, \buttonbr, \buttonhh, "")        
   ButtonGadget  (#feld_nameAendern,x1, y, \buttonbr, \buttonhh, "ndern")      :y + #button_abstand     
   CheckBoxGadget(#feld_neuCheckbox, x, y, \buttonbr, \buttonhh, "Feld neu ")   :y + #button_abstand
   StringGadget  (#feld_neuEingabe,  x, y, \buttonbr, \buttonhh, "")        
   ButtonGadget  (#feld_neuHinzufg, x1, y, \buttonbr, \buttonhh, "hinzufgen")  
   SetGadgetText (#eingabe_links,   "Vorgaben")   
   SetGadgetText (#eingabe_start,   "Start")
   
   y = \subwinlastrow - #button_abstand 
   CheckBoxGadget(#feld_testdaten, x, y, \buttonbr * 2, \buttonhh, "mit Testdaten ?")  
   
   DisableGadget(#feld_nachoben,1):   DisableGadget(#feld_nachunten,1):   DisableGadget(#feld_loeschen,1)
   DisableGadget(#feld_nameChkbox,1): DisableGadget(#feld_nameEingabe,1): DisableGadget(#feld_nameAendern,1)
   DisableGadget(#feld_neuEingabe,1): DisableGadget(#feld_neuHinzufg,1):  HideGadget(#feld_testdaten,1) 

EndWith
EndProcedure

Procedure.i DateiNeu_ButtonOnOff()
;wird aufgerufen von: 
;Case #feld_listview
;Case #feld_nachoben, #feld_nachunten
;Case #feld_loeschen
;Case #feld_vorgaben

DisableGadget(#feld_nachoben,1)
DisableGadget(#feld_nachunten,1)
DisableGadget(#feld_loeschen,1)
DisableGadget(#feld_nameChkbox,1)
DisableGadget(#feld_nameEingabe,1)
DisableGadget(#feld_nameAendern,1)

Protected fbanz = CountGadgetItems(#feld_listview)
Protected fbitem = GetGadgetState(#feld_listview)  ;wer ist markiert ab 0 ? 
Protected flag

If fbitem = -1: flag = 0            ;keins ist markiert
   ElseIf fbitem = 0: flag = 1         ;das 1.ist markiert
   ElseIf fbitem = fbanz-1: flag = 2   ;das letzte ist markiert
   Else: flag = 3                      ;irgendeins dazwischen
EndIf

If flag
   DisableGadget(#feld_loeschen,0)
   DisableGadget(#feld_nameChkbox, 0) 
   SetGadgetText(#feld_nameEingabe, GetGadgetItemText(#feld_listview, fbitem))
EndIf 
 
If flag & 1: DisableGadget(#feld_nachunten,0): EndIf
If flag & 2: DisableGadget(#feld_nachoben,0): EndIf

EndProcedure

Procedure.i DateiDrucken()
   
Protected lvprndata.lvprndata

;eine Erklrung von lvprndata siehe LvPrint2010.pbi

lvprndata\colvon      = 1	 ;ab Spalte 1
lvprndata\colbis      = -1	 ;bis Spalte oder -1 fr die Letzte
lvprndata\faktor      = -15 ;grer/kleiner z.B. 10 oder -10
lvprndata\orientation = 2	 ;1 = Portrait, 2 = Landscape

;wenn es eine Fmt-Datei gibt
With pv.myProgrammvariablen
   If \drkcolvon: lvprndata\colvon = \drkcolvon: EndIf
   If \drkcolbis: lvprndata\colbis = \drkcolbis: EndIf
   If \drkfaktor: lvprndata\faktor = \drkfaktor: EndIf
   If \drkorient: lvprndata\orientation = \drkorient: EndIf
EndWith

LvPrn(#main_liste, lvprndata)

EndProcedure

Procedure.i Einstellungen()

With pv.myProgrammvariablen

Protected x1, x2, br, ba, y
Protected z = \subwinbrhh     ;z ist SubWindowbreite/hhe

If Not \feldanzahl: InfoMeldung(): ProcedureReturn: EndIf
  
  SubWindowOpen("Einstellungen")  
  
  HideGadget(#eingabe_links, 1)
  HideGadget(#eingabe_start, 1)

  x1= 20: x2 = z / 2: br = z / 2 - 20: ba = #button_abstand
  
  y = 10: Frame3DGadget(#PB_Any,        11, y, z-22, ba * 4,    "Farben")
  y + ba: OptionGadget (#farbe_mlvline, x1, y, br,   \buttonhh, "MainListe Gitterlinien")           
          OptionGadget (#farbe_slvline, x2, y, br,   \buttonhh, "SuchListe Gitterlinien")
  y + ba: OptionGadget (#farbe_mlvback, x1, y, br,   \buttonhh, "MainListe Background")           
          OptionGadget (#farbe_menubg,  x2, y, br,   \buttonhh, "Menu Background") 
  y + ba: OptionGadget (#farbe_mlvtext, x1, y, br,   \buttonhh, "MainListe Text")           
  
  y + ba: Frame3DGadget(#PB_Any,      11, y, z-22, ba * 2,    "Fonts")       
  y + ba: OptionGadget (#font_lvtext, x1, y, br,   \buttonhh, "Mainliste: " + \lvfontname)  
          OptionGadget (#font_butext, x2, y, br,   \buttonhh, "Buttons: " + \bufontname)  
  
  y + ba: Frame3DGadget(#PB_Any,      11, y, z-22, ba * 5,    "Diverses")       
  y + ba: CheckBoxGadget(#auto_start, x1, y, br,   \buttonhh, "automatisch starten mit ...")  
              TextGadget(#auto_datei, x2, y, br,   \buttonhh, \startdateiname,#PB_Text_Border|#PB_Text_Center|512|#SS_NOTIFY)  
          SetGadgetState(#auto_start, \autostartflag)
  y + ba: CheckBoxGadget(#auto_save,  x1, y, br+br,\buttonhh, "automatisch speichern bei ProgrammEnde")  
          SetGadgetState(#auto_save,  \autosaveflag)  
  y + ba: CheckBoxGadget(#head_theme, x1, y, br+br,\buttonhh, "Spaltenkopf hat klassische Ansicht (ab nchster Liste)")  
          SetGadgetState(#head_theme, \headertheme)  
  y + ba: CheckBoxGadget(#form_field, x1, y, br+br,\buttonhh, "Formatdatei erstellen (fr formatieren,rechnen,PopUpMenus,Drucken")  
          SetGadgetState(#form_field, \formatflag)  

EndWith

EndProcedure

Procedure.s Zufallsdaten()
Protected k, text$
Protected Dim x$(40)

Restore DateiNeu_ZufaDaten

For k = 1 To 40: Read.s x$(k): Next
text$ = #LF$
text$ + x$(Random(4)+1) + #LF$
text$ + x$(Random(4)+6) + #LF$
text$ + x$(Random(4)+11) + x$(Random(4)+16) + #LF$
text$ + x$(Random(4)+21) + Str(Random(990)+1) + #LF$
text$ + "0" + Str(Random(800)+99) + "-" + Str(Random(9990)+1000) + #LF$ + #LF$
text$ + Str(Random(2)+1) + x$(Random(4)+26) + #LF$
text$ + x$(Random(4)+31) + " + " + x$(Random(4)+36) + #LF$

ProcedureReturn text$
EndProcedure

Procedure.i Datei_Events(wB)
Protected fbitem, name$, j, anz, testdaten

With pv.myProgrammvariablen

Select wB
   
   ;Menupunkte Datei
   Case #menu_new:   DateiNeu()
   Case #menu_load:  DateiLaden(1)
   Case #menu_load1: DateiLaden(0)    ;ohne Spaltentitel
   Case #menu_save:  DateiSpeichern()
   Case #menu_save1: DateiSpeichern(1)
   
   ;Menupunkt LastFileOpen
   Case \lastmenunr[0] To \lastmenunr[#lastfilesmax]
      For j = 0 To #lastfilesmax
         If wB = \lastmenunr[j]: Break: EndIf   
      Next          
      \dateiname = \lastfiles[j]
      DateiLaden(1, 2)
   
   ;Menupunkt Einstellungen
   Case #menu_option: Einstellungen()
      
   ;Menupunkt Drucken
   Case #menu_drucken: DateiDrucken()
   
   ; ---------------------------------------------------------------------
   
   ;im SubWindow fr Felder definieren folgende Gadgets angeclickt
   ;ListViewGadget 
   Case #feld_listview: DateiNeu_ButtonOnOff() 
   
   ;Button Feld nach oben/unten schieben
   Case #feld_nachoben, #feld_nachunten
      fbitem = GetGadgetState(#feld_listview)  ;wer ist markiert ab 0 ? 
      name$ = GetGadgetItemText(#feld_listview, fbitem)  
      RemoveGadgetItem(#feld_listview, fbitem)
      If wB = #feld_nachoben: fbitem - 1: Else: fbitem + 1: EndIf 
      AddGadgetItem(#feld_listview, fbitem, name$)
      SetGadgetState(#feld_listview, fbitem)
      DateiNeu_ButtonOnOff() 
   
   ;Button Feld lschen
   Case #feld_loeschen
      fbitem = GetGadgetState(#feld_listview)  ;wer ist markiert ab 0 ? 
      If fbitem > -1
         RemoveGadgetItem(#feld_listview, fbitem)
         SetGadgetState(#feld_listview, fbitem)
         DateiNeu_ButtonOnOff()
      EndIf   
   
   ;Checkbox Eingabefeld fr Feld ndern aktivieren
   Case #feld_nameChkbox
      If GetGadgetState(#feld_nameChkbox) 
         DisableGadget(#feld_nameEingabe, 0)
         DisableGadget(#feld_nameAendern, 0)
      Else
         DisableGadget(#feld_nameEingabe, 1)
         DisableGadget(#feld_nameAendern, 1)    
      EndIf

   ;Button Feld Name aendern
   Case #feld_nameAendern
      fbitem = GetGadgetState(#feld_listview)  ;wer ist markiert ab 0 ? 
      name$ = Trim(GetGadgetText(#feld_nameEingabe))
      If SpaltenNameOk(#feld_listview, name$)
        SetGadgetItemText(#feld_listview, fbitem, name$)
        SetGadgetState(#feld_listview, fbitem)
      EndIf

   ;Checkbox Eingabefeld fr Feld neu aktivieren
   Case #feld_neuCheckbox   
      If GetGadgetState(#feld_neuCheckbox) 
         DisableGadget(#feld_neuEingabe, 0)
         DisableGadget(#feld_neuHinzufg, 0)
      Else
         DisableGadget(#feld_neuEingabe, 1)
         DisableGadget(#feld_neuHinzufg, 1)    
      EndIf
      
   ;Button Feld neu hinzufuegen
   Case #feld_neuHinzufg
      name$ = Trim(GetGadgetText(#feld_neuEingabe))
      If SpaltenNameOk(#feld_listview, name$)
         AddGadgetItem(#feld_listview, -1, name$)
      EndIf   
   
   ;Button Feld Vorgaben
   Case #eingabe_links
      
      If \progflag = #menu_new
         ClearGadgetItems(#feld_listview) 
         Restore DateiNeu_FeldNamen  
         Read.i anz  
         For j = 1 To anz
            Read.s name$: AddGadgetItem(#feld_listview, -1, name$)
         Next 
         HideGadget(#feld_testdaten, 0)
         SetGadgetState(#feld_listview, 0)
         DateiNeu_ButtonOnOff()  
      EndIf   
   
   ;Button Start
   Case #eingabe_start

      If \progflag = #menu_new
      
         ;erst auslesen, denn gleich wird das Fenster zerstrt incl. Inhalt
         \feldanzahl = CountGadgetItems(#feld_listview) 
         For j = 1 To \feldanzahl 
          \feldnamen[j] = Trim(GetGadgetItemText(#feld_listview, j-1))
         Next 
         testdaten = GetGadgetState(#feld_testdaten)  
         SubWindowClose()
         
         CreateListIconGadget()
         
         \dateiname = "": \datensatz = "": ;\formatflag = 0
         
         If testdaten
            For j = 1 To 22
               AddGadgetItem(#main_liste, 0, Zufallsdaten())
            Next
         EndIf  
         
         \dateiname = "test.txt"
         If \formatflag: FormatIniFile(\dateiname, #read|#write): EndIf
         
         SetWindowDateiInfo()
         ListeAutosize(#main_liste) 
   
      EndIf
   
   ;im SubWindow fr Einstellungen folgende Gadgets angeclickt
   
   Case #farbe_mlvline: ColorRequester1(@ \lvlinecolor)
   Case #farbe_mlvback: ColorRequester1(@ \lvbackcolor) 
   Case #farbe_mlvtext: ColorRequester1(@ \lvtextcolor) 
   Case #farbe_slvline: ColorRequester1(@ \lvlinecolor1) 
   Case #farbe_menubg:  ColorRequester1(@ \menubackcolor) 

   Case #font_lvtext: If FontRequester(\lvfontname,\lvfonthoehe,0)
                         \lvfontname = SelectedFontName()
                         \lvfonthoehe = SelectedFontSize()
                         SetColorAndFont()
                         SubWindowClose()
                         ListeAutosize(#main_liste)                      
                      EndIf  
   Case #font_butext: If FontRequester(\bufontname,\bufonthoehe,0)
                         \bufontname = SelectedFontName()
                         \bufonthoehe = SelectedFontSize()
                         SetColorAndFont()
                         SubWindowClose()
                      EndIf
                      
   Case #auto_save:   \autosaveflag = GetGadgetState(#auto_save) 
   Case #auto_start:  \autostartflag = GetGadgetState(#auto_start) 
   Case #auto_datei:  \startdateiname = GetFilePart(DateiAuswahlLoad())
                      SetGadgetText(#auto_datei, \startdateiname)
                      
   Case #head_theme:  \headertheme = GetGadgetState(#head_theme) 
   Case #form_field:  \formatflag = GetGadgetState(#form_field)
                      If \formatflag: FormatIniFile(\dateiname, #write): EndIf

EndSelect

EndWith
EndProcedure

DataSection
DateiNeu_FeldNamen:
   Data.i 8
   Data.s "Vorname","Nachname","Plz/Ort","Strasse","Tel.","Handy","Div.","?"
   
DateiNeu_ZufaDaten:
   Data.s "Otto ", "Mike ", "Hans-Jrgen ", "Ulrike ", "Familie "
   Data.s "Meier", "Bremer", "Mller", "Holzfller", "Rappel"
   Data.s "12345 ", "35793 ", "48265 ", "72561 ", "55127 "
   Data.s "Wieda", "Bremen", "Kuhdorf", "Neustadt", "Bonn"
   Data.s "Dorfstr. ", "Am Anger ", "Krugkoppel ", "Baumweg ", "Am Teich " 
   Data.s " Hunde", " Katzen", " Vgel", " Pferde", " Schafe" 
   Data.s "VW", "Opel", "BMW", "Ford", "Fahrrad", "Mercedes", "Mofa", "Porsche", "Audi", "Toyota" 
EndDataSection       


; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; CursorPosition = 154
; FirstLine = 125
; Folding = -z
; EnableXP