Procedure.i FormatIniFile(dat$, flag)
Protected j, ok, p, fmt
Protected fmtdatei$ = "test.fmt"

With pv.myProgrammvariablen   
   
If \formatflag 

   If dat$
      p = FindString(dat$, ".", 1)
      If p
         fmtdatei$ = Left(dat$, p-1) + ".fmt"      
      Else
         fmtdatei$ = dat$ + ".fmt"
      EndIf
   EndIf
   
   \feldformatdatei = fmtdatei$  ;wird fr Notepad und Summe gebraucht
         
   ok = OpenPreferences(fmtdatei$)
   If Not ok: CreatePreferences(fmtdatei$): EndIf
   
   If flag & #read = #read      

      PreferenceGroup("Feldformat")
         For j = 1 To \feldanzahl
            \feldformat[j] = ReadPreferenceString ("Feld" + Str(j), "")
            fmt = Asc(LCase(\feldformat[j]))
            Select fmt
               Case 'l': LvJustifyColumn(GadgetID(#main_liste), j, #LVCFMT_LEFT)
               Case 'm': LvJustifyColumn(GadgetID(#main_liste), j, #LVCFMT_CENTER)
               Case 'r': LvJustifyColumn(GadgetID(#main_liste), j, #LVCFMT_RIGHT)
            EndSelect            
         Next
      
      PreferenceGroup("Feldformel")
         j = 0
         Repeat           
            \feldformelanz = j: j + 1
            \feldformel[j] = ReadPreferenceString ("Formel" + Str(j), "")
         Until Not \feldformel[j] Or j > #maxfelder
         
      PreferenceGroup("FeldPopup")
         \feldpopupdatei = ReadPreferenceString ("Dateiname", "")
         \datummaske     = ReadPreferenceString ("Datummaske", "%dd.%mm.%yy") 
   
      PreferenceGroup("Drucken")
         \drkcolvon = ReadPreferenceInteger("vonSpalte", 1)
         \drkcolbis = ReadPreferenceInteger("bisSpalte", -1)
         \drkfaktor = ReadPreferenceInteger("Faktor %", -10)
         \drkorient = ReadPreferenceInteger("Richtung", 1)
         
      PreferenceGroup("Feldfixbreite")
         \maxcolbreite = ReadPreferenceInteger("maxColBreite", 180) 
         For j = 1 To \feldanzahl
            \feldfixbreite[j] = ReadPreferenceInteger("Feld" + Str(j), 0) 
         Next
         
   EndIf
   
   If flag & #write = #write
   
      RemovePreferenceGroup("Feldformat")
      PreferenceGroup("Feldformat")
         For j = 1 To \feldanzahl
            WritePreferenceString ("Feld" + Str(j), \feldformat[j])
         Next
               
      RemovePreferenceGroup("Feldformel")
      PreferenceGroup("Feldformel")
         For j = 1 To \feldformelanz
            WritePreferenceString ("Formel"+Str(j), \feldformel[j])
         Next         
     
      RemovePreferenceGroup("FeldPopup")
      PreferenceGroup("FeldPopup")
         WritePreferenceString ("Dateiname", \feldpopupdatei)
         WritePreferenceString ("Datummaske",  \datummaske) 

      RemovePreferenceGroup("Drucken")
      PreferenceGroup("Drucken")
         WritePreferenceInteger("vonSpalte", \drkcolvon)
         WritePreferenceInteger("bisSpalte", \drkcolbis)
         WritePreferenceInteger("Faktor %",  \drkfaktor)
         WritePreferenceInteger("Richtung",  \drkorient)
         
      RemovePreferenceGroup("Feldfixbreite")
      PreferenceGroup("Feldfixbreite")
         WritePreferenceInteger("maxColBreite", \maxcolbreite)      
         For j = 1 To \feldanzahl
            If \feldfixbreite[j]
               WritePreferenceInteger("Feld" + Str(j), \feldfixbreite[j])
            EndIf
         Next
         
      RemovePreferenceGroup("Info")
      PreferenceGroup("Info")
         PreferenceComment("[Feldformat]")
         PreferenceComment(" 1. L,R,M fr Ausrichtung der Spalten")
         PreferenceComment(" 2. G,K,Z fr Gro,Klein,Zahlen")
         PreferenceComment(" 3. eine Zahl fr Kommastellen")
         PreferenceComment(" wenn definiert, mu mit LRM begonnen werden")
         PreferenceComment(" also erst LRM, dann GKZ, dann Kommastellen")
         PreferenceComment(" ist Ergebnis 0, mit angehngtem Minus wird Ergebnis gelscht")
         PreferenceComment(" Feld1 = RZ2 bedeutet rechtsbndig, Zahl mit 2 Kommastellen")
         PreferenceComment(" Feld1 = MZ- bedeutet mittig, Zahl ohne Kommastellen, lschen wenn 0")
         PreferenceComment("")
         PreferenceComment("[Feldformel]")
         PreferenceComment(" Formel1 = #3 = #1 + #2")
         PreferenceComment(" Formel2 = #4 = 113 + #4 - #5")
         PreferenceComment("")
         PreferenceComment("[FeldPopup]")
         PreferenceComment(" Dateiname = z.B. xyzPopUp.pop fr Spalten-Menueintrge")
         PreferenceComment(" Datummaske = siehe PB Hilfe")
         PreferenceComment("")
         PreferenceComment("[Drucken]")
         PreferenceComment(" bisSpalte: wenn -1 = alle Spalten")
         PreferenceComment(" Faktor %: grer/kleiner z.B. 10 oder -10")
         PreferenceComment(" Richtung: 1 = Portrait, 2 = Landscape")
         PreferenceComment("")
         PreferenceComment("[Feldfixbreite]")
         PreferenceComment(" Feld4 = 250")
         PreferenceComment("")
         PreferenceComment("[FeldSumme]")
         PreferenceComment(" Feld3 = 0  ; Summe Spalte 3 ohne Kommastellen")
         PreferenceComment(" Feld5 = 2  ; Summe Spalte 5 mit 2 Kommastellen")
         PreferenceComment(" Feld5 = 2d ; Durchschnitt Spalte 5 mit 2 Kommastellen")
         
   EndIf
      
   ClosePreferences()

EndIf
  
EndWith
EndProcedure

Procedure.f FormatOpGetWert(op$)
Protected wert.f, nr, inh$

op$ = Trim(op$)
If Asc(op$) = '#'
   nr = Val(Mid(op$, 2))
   inh$ = GetGadgetText(pv\eingabepbnr[nr])
   wert = ValF(inh$)
Else
   wert = ValF(op$)
EndIf

ProcedureReturn wert
EndProcedure

Procedure.s FormatOpKomma(zahl$, format$)
   
Protected.i komm = Val(format$)   
Protected.i fmt1 = Asc(format$)
Protected.i fmt2 = Asc(Mid(format$, 2))   
Protected.f wert = ValF(zahl$)

Select fmt1
   Case '-': komm = 0: zahl$ = StrF(wert, komm)
   Case '0' To '9':    zahl$ = StrF(wert, komm)
EndSelect   

If wert = 0 
   ;wenn fmt ein Minuszeichen
   If fmt1 = '-' Or fmt2 = '-'
      zahl$ = ""
   EndIf
EndIf

ProcedureReturn zahl$
EndProcedure

Procedure.s FormatOpRechnen(formel$)

;Anzahl Ops ermitteln
Protected p, posi, anz, *c.character = @formel$

   While *c\c
      Select *c\c      
         Case 42, 43, 45, 47: anz + 1 ; * + - / =
         Case 61: posi = p + 1: anz + 1
      EndSelect   
      *c + 1: p + 1
   Wend
   If anz < 1: ProcedureReturn "": EndIf
   formel$ = Mid(formel$, posi)

;Formel zerlegen
Protected j, lg, k
Protected opchar, opwert.f, erg.f

For j = 1 To anz
      
   *c.character = @formel$
   lg = Len(formel$)
   
   For k = 1 To lg
      Select *c\c
         Case 42, 43, 45, 47, 61
            opchar = *c\c
            formel$ = Mid(formel$, k+1)
            opwert = FormatOpGetWert(formel$)  
            Break 
      EndSelect   
      *c + 1
   Next
   
   Select opchar
      Case 61: erg = opwert 
      Case 42: erg * opwert
      Case 43: erg + opwert
      Case 45: erg - opwert
      Case 47: If opwert = 0: opwert = 1: EndIf
               erg / opwert
   EndSelect 
   
Next
   
ProcedureReturn StrF(erg)
EndProcedure

Procedure.i Format_Rechnen()
Protected j, formel$, zielfeldnr, zahl$

For j = 1 To pv\feldformelanz
   formel$ = ReplaceString(pv\feldformel[j], " ", "")    
   If Asc(formel$) = '#'   ;ist 1.Zeichen ein # ?
      zielfeldnr = Val(Mid(formel$, 2))                  
      zahl$ = FormatOpRechnen(formel$) 
      zahl$ = FormatOpKomma(zahl$, Mid(pv\feldformat[zielfeldnr], 3))
      SetGadgetText(pv\eingabepbnr[zielfeldnr], zahl$)
   EndIf
Next

EndProcedure 
 
Procedure.i Format_1(nr)
;nr ist der FeldIndex vom Stringgadget welches den Focus verliert
; \formatflag wurde bereits abgefragt

Protected j, inh$, fmt1, fmt2, wert.f, komm

With pv.myProgrammvariablen

   If \feldformat[nr]
      inh$ = GetGadgetText(\eingabepbnr[nr])   ;:Debug inh$
      fmt1 = Asc(Mid(\feldformat[nr], 2, 1))   ;:Debug fmt1
      ;fmt2 = Asc(Mid(\feldformat[nr], 3, 1))   ;:Debug fmt2 
      ;fmt3 = Asc(Mid(\feldformat[nr], 4, 1))   ;:Debug fmt3 
      Select fmt1
         Case 'G', 'g': inh$ = LCase(inh$): SetGadgetText(\eingabepbnr[nr], inh$)
         Case 'K', 'k': inh$ = UCase(inh$): SetGadgetText(\eingabepbnr[nr], inh$)
         Case 'Z', 'z': inh$ = ZCase(inh$): SetGadgetText(\eingabepbnr[nr], inh$)
            
                        inh$ = FormatOpKomma(inh$, Mid(\feldformat[nr], 3))
                        SetGadgetText(\eingabepbnr[nr], inh$)

                        If \feldformelanz: Format_Rechnen(): EndIf                                                
      EndSelect
   EndIf

EndWith
EndProcedure

Procedure.i FormatNotepad(dat$)

If pv\formatflag And dat$
   RunProgram("notepad", dat$, "", #PB_Program_Wait)
   FormatIniFile(pv\dateiname, #read)
Else
   InfoMeldung(2, "nicht aktiviert" + #LF$ + "siehe Datei/Einstellungen")   
EndIf

EndProcedure

Procedure.i FormatPopUpGetMenu(*p.Point, parentid)
Protected ok, j, k, text$

If *p\x = -1 Or *p\y = -1
   ProcedureReturn
Else
   ok = OpenPreferences(pv\feldpopupdatei)
   If Not ok: CreatePreferences(pv\feldpopupdatei): EndIf
   
   ;wenn Gruppe Spalte x nicht existiert, dann anlegen
   If Not PreferenceGroup("Spalte" + Str(*p\x))
      WritePreferenceString ("1", "")
   EndIf
   
   If IsMenu(#main_popup): FreeMenu(#main_popup) : EndIf
   
   CreatePopupMenu(#main_popup)
   
   j = 0
   Repeat           
      j + 1: text$ = ReadPreferenceString (Str(j), "")
      If text$
         If j % 12 = 1
            AppendMenu_(MenuID(#main_popup),#MF_MENUBREAK,1000 + j, text$)    
         Else
            MenuItem(1000 + j, text$)
         EndIf         
      EndIf
   Until Not text$    
       
   ClosePreferences()
   DisplayPopupMenu(#main_popup, parentid) 
    
EndIf   
EndProcedure

Procedure.s FormatPopUpGetString(wB)
   
Protected menu$ = Trim(GetMenuItemText(#main_popup, wB))  ;wB ist hier 1000 to 1100
Protected first = Asc(menu$)

Select first
      
   Case '_', 123 To 254
      menu$ = Mid(menu$, 2)
      
   Case '#'   
      
      If Left(LCase(menu$), 6) = "#datum" 
         ;menu$ = FormatDate(pv\datummaske, Date())
         menu$ = FormatDate(pv\datummaske, GetGadgetState(#calendar_gadget))
      EndIf       
      
EndSelect

ProcedureReturn menu$      
EndProcedure 

Procedure.i FormatPopUpInsertString(menu$)
Protected von, bis, diff, text$
Protected j = GetFeldEingabeIndex(GetActiveGadget())

If j
   Protected nr = pv\eingabepbnr[j]
   Protected id = GadgetID(nr)
   Protected lg = SendMessage_(id, #EM_LINELENGTH , -1, 0)  ;:Debug lg
   
   SendMessage_(id, #EM_GETSEL, @von, @bis)     ;:Debug von: Debug bis
   text$ =  " " + menu$
   If von = 0 And bis = lg: text$ = menu$: EndIf
   SendMessage_(id, #EM_REPLACESEL, #False, @text$) 
   SendMessage_(id, #EM_SETSEL, $ffff, $ffff)  ;Caret ans Ende
EndIf
   
EndProcedure

Procedure.i FormatPopUpSort()
Protected ok, nr, j, k, text$
Protected Dim txt$(0)   

   ok = OpenPreferences(pv\feldpopupdatei)
   If Not ok: CreatePreferences(pv\feldpopupdatei): EndIf
   
   For nr = 1 To pv\feldanzahl
      
      Dim txt$(0)
      PreferenceGroup("Spalte" + Str(nr))
      j = 0 
      Repeat           
         j + 1: text$ = ReadPreferenceString (Str(j), "") 
         If text$: ReDim txt$(j): txt$(j) = text$: EndIf
      Until Not text$  
      
      SortArray(txt$(), #PB_Sort_Ascending, 1, j-1)
         
      RemovePreferenceGroup("Spalte" + Str(nr))
      PreferenceGroup("Spalte" + Str(nr))
      For k = 1 To j - 1 
         WritePreferenceString (Str(k), txt$(k))
      Next
   
   Next
   
   ClosePreferences()      
   ;Infomeldung(1, "PopUp-Datei sortiert")   
   
EndProcedure

Procedure.i FormatSumme()
Protected i, j, k
   
With pv.myProgrammvariablen
If \formatflag And IsGadget(#main_liste)     
   
   ;fs() enthlt die Definitionen 
   ;Leerstring ist gleich keine Summe bilden
   ;0 oder 2 steht fr die Anzahl Kommastellen 
   ;ein 2,d = 2 Kommastellen und Durchshnitt
   Protected Dim fs.s(\feldanzahl)   
   
   OpenPreferences(\feldformatdatei)
   PreferenceGroup("FeldSumme")
   For j = 1 To \feldanzahl
      fs(j) = ReadPreferenceString("Feld" + Str(j), "") 
      If fs(j): i + 1: EndIf
   Next
   ClosePreferences()
   
   If i = 0: InfoMeldung(2, "keine Summenfelder in Formatdatei"): ProcedureReturn: EndIf
   
   Protected Dim sum.f(\feldanzahl)
   Protected col1text$ = "Summe"   ;first chr ist 255 wegen Sortieren 
   Protected iitem$, item$ = #LF$ + col1text$
   
   Protected anz = CountGadgetItems(#main_liste) -1  
   If anz = -1: InfoMeldung(2, "Liste leer"): ProcedureReturn: EndIf
   
   ;gibt es schon eine Summe Zeile ?
   If FindString(GetGadgetItemText(#main_liste, 0, 1), col1text$, 1)
      RemoveGadgetItem(#main_liste, 0) 
   ElseIf FindString(GetGadgetItemText(#main_liste, anz, 1), col1text$, 1)
      RemoveGadgetItem(#main_liste, anz)    
   EndIf
   
   anz = CountGadgetItems(#main_liste) -1
   
   For j = 0 To anz 
      For k = 1 To \feldanzahl
         If fs(k)
            iitem$ = GetGadgetItemText(#main_liste, j, k)
            sum(k) + ValF(iitem$) 
         EndIf         
      Next          
   Next   
   
   anz + 1
   
   For j = 1 To \feldanzahl      
      If fs(j)
         If Right(LCase(RTrim(fs(j))), 1) = "d"
            item$ + StrF(sum(j) / anz, Val(fs(j)))
         Else
            item$ + StrF(sum(j), Val(fs(j)))
         EndIf         
      EndIf
      item$ + #LF$
   Next
   
   AddGadgetItem(#main_liste, anz, item$)  
   ListeAutosize(#main_liste)
   SetGadgetItemColor(#main_liste, anz, #PB_Gadget_FrontColor, $1D1569, -1)
   SendMessage_(pv\mainlvid, #LVM_ENSUREVISIBLE, anz, 0) 
   SetGadgetItemState(#main_liste, anz, #PB_ListIcon_Selected)
   SetActiveGadget(#main_liste)
   
EndIf
EndWith
EndProcedure

; IDE Options = PureBasic 4.50 RC 2 (Windows - x86)
; CursorPosition = 381
; FirstLine = 155
; Folding = Bw-
; EnableXP